/*jslint vars: true, plusplus: true, devel: true, nomen: true, regexp: true, indent: 4, maxerr: 50 */
/*global $, Folder*/

#include "polyfills/forEach.js"
#include "polyfills/json3.js"

$._simian_common = {
	parseObj: function(o) {
		var str = "";
		  for (prop in o) {
			str += prop + " [" + typeof o[prop] + "]: " + o[prop] + ".\n";
		  }
		alert(str);
	},

	logMessage : function (msg) {
		$.writeln(msg);	 // Using '$' object will invoke ExtendScript Toolkit, if installed.
	},
}

$._simian_AEFT = {
	getVersionInfo : function() {
		return 'AEft ' + app.version + 'x' + app.buildNumber;
	},

	getRenderQueueItemCount : function() {
		return app.project.renderQueue.numItems;
	},

	getRenderQueueQueuedItemCount : function() {
		var itemCount = 0;
		for (var i=1; i <= app.project.renderQueue.numItems; i++) {
			if (app.project.renderQueue.items[i].status == RQItemStatus.QUEUED) {
				itemCount = itemCount + 1;
			}
		}
		return itemCount;
	},

	// resulting object doesn't work outside extendscript environment?
	getRenderQueue : function() {
		$._simian_common.logMessage(':: getRenderQueue');
		// $._simian_common.logMessage(app.project.renderQueue);
		return JSON.stringify(app.project.renderQueue);
	},

	getCompletedRenderQueueItems : function() {
		$._simian_common.logMessage(':: getCompletedRenderQueueItems');
		var completedItems = [];
		for (var i=1; i <= app.project.renderQueue.numItems; i++) {
			if (app.project.renderQueue.items[i].status == RQItemStatus.DONE) {
				var item = {};
				item.name = app.project.renderQueue.items[i].comp.name;
				item.file = app.project.renderQueue.items[i].outputModules[1].file.relativeURI; // TODO: multiple output modules?
				completedItems.push(item);
			}
		}
		return completedItems;
	},

	importFile : function(path) {
		// TODO modify for AEFT
        if (app.project) {
			app.project.importFile(new ImportOptions(new File(path)));
        }
    },

	importComments : function(commentObject) {
		// alert("Test");
		var activeItem = app.project.activeItem;
		if(!(activeItem instanceof CompItem))
		{
			alert("Please select a composition");
			return "##NOCOMP##";
		}
		else
		{
			if (activeItem) {
				var markers = activeItem.markerProperty;
				if (markers) {
			  //  clear old markers
			//   var markersToRemove = [];
			//   var numMarkers = markers.numMarkers;
			// 			  if (numMarkers > 0) {
			// 				  var marker_index = 1;
			// 				  for(var current_marker	=	markers.getFirstMarker();
			// 					  current_marker	!==	undefined;
			// 					  current_marker =	markers.getNextMarker(current_marker)){
			// 		  var marker_name = current_marker.name.split(":");
			// 		  if(marker_name[0] == "Simian Comment") {
			// 			  markersToRemove.push(current_marker);
			// 		  }
			// 		}
	
			// 		markersToRemove.forEach(function(m) {
			// 		  markers.deleteMarker(m);
			// 		});
			// 	  }
	
	
			  commentObject.forEach(function(comment) {
				//alert("@" + comment.timestamp + ": " + comment.comment);
				//alert(markers);
				var newCommentMarker = new MarkerValue('[Simian Comment] ' + comment.comment);
				activeItem.markerProperty.setValueAtTime(parseFloat(comment.timestamp),newCommentMarker);

				// var newCommentMarker  		= markers.createMarker(parseFloat(comment.timestamp));
					//   newCommentMarker.name 		= 'Simian Comment: user ' + comment.user_id;
					//   newCommentMarker.comments 	= comment.comment;
					//   newCommentMarker.end 		= parseFloat(comment.timestamp);
			  });
			}
		  }
		}
	},


	render : function(queueID, projectID, folderID) {
		$._simian_common.logMessage(':: render');
		for (var i=1; i <= app.project.renderQueue.numItems; i++) { 
			$._simian_common.logMessage('> attach ' + i );
			app.project.renderQueue.item(i).onstatus = $._simian_AEFT.onRenderStatus;
			$._simian_common.logMessage('< attached');
		}
		$._simian_common.logMessage(':: render2');

		app.project.renderQueue.render();
		$._simian_common.logMessage(':: rendering complete');

		var eoName;
		if (Folder.fs == 'Macintosh') {
		eoName = "PlugPlugExternalObject";
		} else {
		eoName = "PlugPlugExternalObject.dll";
		}
		var mylib 	 = new ExternalObject('lib:' + eoName);
		var eventObj = new CSXSEvent();
		eventObj.type = "com.gosimian.infusion.events.AEFT_RenderQueueComplete";
		// eventObj.data = '{"jobID":"' + jobID + '", "queueID":"' + queueID + '", "queueLabel":"' + queueLabel + '"}';
		var eventData = {
			queueID: queueID,
			projectID: projectID,
			folderID: folderID,
			items: $._simian_AEFT.getCompletedRenderQueueItems()
		};
		eventObj.data = JSON.stringify(eventData);
		$._simian_PPRO.logMessage(eventObj.data);
		eventObj.dispatch();

	},

	// --- Render Callbacks ---
	onRenderStatus : function() {
		// callback passes the RenderQueueItem as this
		$._simian_common.logMessage(':: onRenderStatus');
		if(this.status == RQItemStatus.RENDERING) {
			$._simian_common.logMessage('> status = rendering');
		} else if(this.status == RQItemStatus.DONE) {
			$._simian_common.logMessage('> status = done');
		} else 
	}

	// --- End Render Callbacks ---
}

$._simian_PPRO = {
    parseObj: function(o) {
      var str = "";
        for (prop in o) {
          str += prop + " [" + typeof o[prop] + "]: " + o[prop] + ".\n";
        }
      alert(str);
    },

    keepPanelLoaded : function() {
		app.setExtensionPersistent("com.gosimian.infusion", 1);
	  },

    removePersistent : function() {
		app.setExtensionPersistent("com.gosimian.infusion", 0);
	  },

    getVersionInfo : function() {
		return 'PPro ' + app.version + 'x' + app.build;
	},

	getUserName : function() {
		var 	homeDir = new File('~/');
		var 	userName = homeDir.displayName;
		homeDir.close();
        return userName;
	},

	getProjectPath : function() {
		return app.project.path;
	},

    exportCurrentFrameAsPNG : function() {
        app.enableQE();

        var activeSequence	= qe.project.getActiveSequence(); 	// note: make sure a sequence is active in PPro UI

        if (activeSequence) {
	        var time 			= activeSequence.CTI.timecode; 	// CTI = Current Time Indicator.
	        var outputPath  	= new File("~/Desktop");
			var outputFileName	= outputPath.fsName + $._simian_PPRO.getSep() + time + '_' + activeSequence.name;

            activeSequence.exportFramePNG(time, outputFileName);

		} else {
			alert("Active sequence required.");
		}
	},

    getSep : function() {
		if (Folder.fs == 'Macintosh') {
		    return '/';
		} else {
			return '\\';
		}
	},

  // --- Active Sequence Functions ---

  // dev notes:
  // Sequence.setPlayerPosition expects a "ticks" value
  // There are 254016000000 ticks per second
  // ticks_per_second / timebase = framerate

  sequence_getName: function() {
    if (app.project.activeSequence) {
      return app.project.activeSequence.name;
    } else {
      return "!!NONE!!";
    }
  },

  sequence_getResolution : function() {
    var activeSequence = app.project.activeSequence;
    // this.logMessage(activeSequence.frameSizeHorizontal + "x" + activeSequence.frameSizeVertical);
    var returnObj = {
      width: activeSequence.frameSizeHorizontal,
      height: activeSequence.frameSizeVertical
    }
    return JSON3.stringify(returnObj);
  },

  // FIXME: Is this used?? Has no effect, and no return besides a log message
  sequence_getTimebase : function() {
    var activeSequence = app.project.activeSequence;
    var timebase = activeSequence.timebase;
    this.logMessage("Timebase: "+timebase);
  },

  sequence_movePlayheadToTimestamp : function(timestampInSeconds) {
    var activeSequence = app.project.activeSequence;
    var ticks = 254016000000 * timestampInSeconds;

    activeSequence.setPlayerPosition(ticks.toString());
  },

  // Move-to-frame not yet working correctly
  sequence_movePlayheadToFrame : function(frame) {
    // var activeSequence = app.project.activeSequence;
    // var timebase = activeSequence.timebase;
    // var fps = 254016000000 / timebase;
    //
    // this.logMessage("Timebase: "+timebase);
    // this.logMessage("Framerate: "+fps);
    //
    // var ticks = timebase * fps;
    // this.logMessage("Ticks: "+ticks);
    // activeSequence.setPlayerPosition(ticks);
  },

  addCommentMarkers : function(commentObject) {
    //alert(commentObject);
    var activeSequence = app.project.activeSequence;
	    if (activeSequence) {
		    var markers		= activeSequence.markers;
		    if (markers) {
          //  clear old markers
          var markersToRemove = [];
          var numMarkers = markers.numMarkers;
				      if (numMarkers > 0) {
					      var marker_index = 1;
					      for(var current_marker	=	markers.getFirstMarker();
							  current_marker	!==	undefined;
							  current_marker =	markers.getNextMarker(current_marker)){
                  var marker_name = current_marker.name.split(":");
                  if(marker_name[0] == "Simian Comment") {
                      markersToRemove.push(current_marker);
                  }
                }

                markersToRemove.forEach(function(m) {
                  markers.deleteMarker(m);
                });
              }


          commentObject.forEach(function(comment) {
            //alert("@" + comment.timestamp + ": " + comment.comment);
            //alert(markers);
            var newCommentMarker  		= markers.createMarker(parseFloat(comment.timestamp));
			      newCommentMarker.name 		= 'Simian Comment: user ' + comment.user_id;
			      newCommentMarker.comments 	= comment.comment;
			      newCommentMarker.end 		= parseFloat(comment.timestamp);
          });
        }
      }
  },

    importFile : function(path) {
        if (app.project) {
            var importThese = new Array();
            importThese[0] = path;

            app.project.importFiles(importThese,
											0,				// suppress warnings
                                            app.project.rootItem,
											0);				// import as numbered stills
        }
    },

    render : function(outputPresetPath, outPath, queueID, queueLabel) {
  		app.enableQE();
  		var activeSequence = qe.project.getActiveSequence();  // we use a QE DOM function, to determine the output extension.
  		if (activeSequence)	{
  			app.encoder.launchEncoder();	// This can take a while; let's get the ball rolling.

  			/*var timeSecs	= activeSequence.CTI.secs;		// Just for reference, here's how to access the CTI
  			var timeFrames	= activeSequence.CTI.frames;	// position, for the active sequence.
  			var timeTicks	= activeSequence.CTI.ticks;
  			var timeString	= activeSequence.CTI.timecode;

  			var seqInPoint	= app.project.activeSequence.getInPoint();	// new in 9.0
  			var seqOutPoint	= app.project.activeSequence.getOutPoint();	// new in 9.0*/

  			var projPath   	= new File(app.project.path);
  			//var outputPath  = Folder.selectDialog("Choose the output directory");
        var outputPath = outPath;
        // alert(outputPath);

  			if ((outputPath) && projPath.exists){
  				var outPreset  		= new File(outputPresetPath);
  				if (outPreset.exists === true){
  					var outputFormatExtension   	= 	activeSequence.getExportFileExtension(outPreset.fsName);
  					if (outputFormatExtension){

  						 var outputFilename = activeSequence.name + '.' + outputFormatExtension;

              //TODO append random string?
  						var fullPathToFile 	= 	outputPath +
  												$._simian_PPRO.getSep() +
  												activeSequence.name +
  												"." +
  												outputFormatExtension;

  						var outFileTest = new File(fullPathToFile);

  						if (outFileTest.exists){
  							//var destroyExisting = confirm("A file with that name already exists; overwrite?", false, "Are you sure...?");
  							var destroyExisting = true;
  							if (destroyExisting){
  								outFileTest.remove();
  								outFileTest.close();
  							}
  						}

  						app.encoder.bind('onEncoderJobComplete',	$._simian_PPRO.onEncoderJobComplete);
  						app.encoder.bind('onEncoderJobError', 		$._simian_PPRO.onEncoderJobError);
  						app.encoder.bind('onEncoderJobProgress', 	$._simian_PPRO.onEncoderJobProgress);
  						app.encoder.bind('onEncoderJobQueued', 		$._simian_PPRO.onEncoderJobQueued);

  						// use these 0 or 1 settings to disable some/all metadata creation.
  						app.encoder.setSidecarXMPEnabled(0);
  						app.encoder.setEmbeddedXMPEnabled(0);

  			            // For reference, here's how to export from within PPro (blocking further user interaction).

  			            // activeSequence.exportAsMediaDirect(fullPathToFile,  outPreset.fsName, app.encoder.ENCODE_WORKAREA);

  						var jobID = app.encoder.encodeSequence(	app.project.activeSequence,
  																fullPathToFile,
  																outPreset.fsName,
  																app.encoder.ENCODE_WORKAREA,
  																1);    // Remove from queue upon successful completion?
  						// $._simian_PPRO.logMessage('jobID = ' + jobID + ', queueID = '+ queueID);

              $._simian_PPRO.onRenderJobCreated(jobID, queueID, queueLabel);

  						outPreset.close();
              return jobID;
  					}
  				} else {
  					alert("Could not find output preset.\n\nPath: "+outputPresetPath);
  				}
  			} else {
  				alert("Could not find/create output path.");
  			}
  			projPath.close();
		  } else {
		    alert("No active sequence.");
	    }
	},

  // --- Render Callbacks ---
  onRenderJobCreated : function(jobID, queueID, queueLabel) {
    var eoName;
    if (Folder.fs == 'Macintosh') {
      eoName = "PlugPlugExternalObject";
    } else {
      eoName = "PlugPlugExternalObject.dll";
    }
    var mylib 	 = new ExternalObject('lib:' + eoName);
    var eventObj = new CSXSEvent();
    eventObj.type = "com.gosimian.events.RenderJobCreatedEvent";
    eventObj.data = '{"jobID":"' + jobID + '", "queueID":"' + queueID + '", "queueLabel":"' + queueLabel + '"}';
    $._simian_PPRO.logMessage(eventObj.data);
    eventObj.dispatch();
  },

	onEncoderJobComplete : function (jobID, outputFilePath) {
		var eoName;
		var outFilename;

		if (Folder.fs == 'Macintosh') {
			eoName = "PlugPlugExternalObject";
			outFilename = outputFilePath;
		} else {
			eoName = "PlugPlugExternalObject.dll";
			outFilename = outputFilePath.replace(/\\/g, "\\\\");
		}

		var mylib 	 = new ExternalObject('lib:' + eoName);
		var eventObj = new CSXSEvent();

		eventObj.type = "com.gosimian.events.RenderEvent";
		eventObj.data =  '{"status": "success", "jobID": "'+ jobID + '", "outFile": "' + outFilename + '"}';
    	eventObj.dispatch();
	},

	onEncoderJobError : function (jobID, errorMessage) {
		var eoName;

		if (Folder.fs == 'Macintosh') {
			eoName = "PlugPlugExternalObject";
		} else {
			eoName = "PlugPlugExternalObject.dll";
		}

		var mylib 	 = new ExternalObject('lib:' + eoName);
		var eventObj = new CSXSEvent();

		eventObj.type = "com.gosimian.events.RenderEvent";
		eventObj.data =  '{"status": "failed", "jobID": "'+ jobID + '", "message": "' + errorMessage + '"}';
    	eventObj.dispatch();
	},

	onEncoderJobProgress : function (jobID, progress) {
		//$._simian_PPRO.message('onEncoderJobProgress called. jobID = ' + jobID + '. progress = ' + progress + '.');
        var eoName;

		if (Folder.fs == 'Macintosh') {
			eoName = "PlugPlugExternalObject";
		} else {
			eoName = "PlugPlugExternalObject.dll";
		}

		var mylib 	 = new ExternalObject('lib:' + eoName);
		var eventObj = new CSXSEvent();

		eventObj.type = "com.gosimian.infusion.RenderProgressEvent";
		eventObj.data =  '{"jobID": "'+ jobID + '", "progress": "' + progress + '"}';
    	eventObj.dispatch();

	},

	onEncoderJobQueued : function (jobID) {
    var eoName;

		if (Folder.fs == 'Macintosh') {
			eoName = "PlugPlugExternalObject";
		} else {
			eoName = "PlugPlugExternalObject.dll";
		}

		var mylib 	 = new ExternalObject('lib:' + eoName);
		var eventObj = new CSXSEvent();

		eventObj.type = "com.gosimian.infusion.RenderQueuedEvent";
		eventObj.data = jobID;
    	eventObj.dispatch();

	    app.encoder.startBatch();
	},


    // --- End Render Callbacks ---

    // --- Utility Functions ---

  logMessage : function (msg) {
     $.writeln(msg);	 // Using '$' object will invoke ExtendScript Toolkit, if installed.
  },

}

$._simian_PPRO.logMessage("[debug] JSX loaded");
