//
// Simian Drawing Canvas / Annotated Commenting Tools
//
var curColor = '#f00';
var curTool = '';
var drawInitialized = false;
var canvas, context, canvaso, contexto, tool;
var currentComment = 10000000;
var drawStack = new Array();
var drawStep = -1;

/*	$('#annotatedComment').keydown(function (e) {
	  if (e.keyCode == 13) {
	  	saveCanvas();
	  }
	});
*/

function init_controls()
{
		/*
	$('.ctrl-cnext').click(function() {
		// Find next comment
		$('.fp-cuepoint').each(function(idx) {
			cid = $(this).attr('id');
			cid = cid.replace('cp_','');
			cid = parseInt(cid);

			if(cid < currentComment)
			{
				simLoadComment(cid,true);
				return false;
			}
		});
	});
	
	$('.ctrl-cprev').click(function() {
		// Find previous comment
		$($(".fp-cuepoint").get().reverse()).each(function(idx) {
			cid = $(this).attr('id');
			cid = cid.replace('cp_','');
			cid = parseInt(cid);

			if(cid > currentComment)
			{
				simLoadComment(cid,true);
				return false;
			}
		});
	});
	*/
	
	$('.dColorSel').click(function() {
		
		var thisColor = $(this).attr('cvar');
		$('.dColorWheel').attr('class', function(i, c){
			return c.replace(/(^|\s)dColorSel_\S+/g, '');
		});
		$('.dColorWheel').addClass('dColorSel_'+thisColor);
		
		$('.dColorSel').removeClass('selected');
		$(this).addClass('selected');
		
		var newColor = $('.dColorSel_'+thisColor).css('color');
		curColor = newColor;
		if(context)
		{
		   	context.strokeStyle=curColor; 	
		}	
	});
	
	$('.sp-cuepoint').mouseover(function() {
		content = $(this).next('span').html();
		$('#commentBubble').hide();
		
		// Get Offset
		leftOffset = $(this).offset().left;
		topOffset = $(this).offset().top;
		
		$('.cuepoint_hover').html(content);
		$('.cuepoint_hover').show();
		leftOffset -= 60;
		$('.cuepoint_hover').css('left', leftOffset + 'px');
		calcHeight = $('.cuepoint_hover').height();

		if($('.prj-comments').length > 0) // Back end
			calcHeight += 95;
		else
			calcHeight += 150;
		
		$('.cuepoint_hover').css('top', (topOffset - calcHeight) + 'px');
	 });
	 
	  $('.sp-cuepoint').mouseout(function() {
		$('.cuepoint_hover').hide();
	 });
	 
}

function simHideComment()
{
	$('.commentInfo').hide();
	$('#commentCanvas').hide();
	$('#displayCanvas').hide();
	$('#imageTemp').hide();
}

function simLoadComment(idx, doScroll)
{
	//$('.commentInfo').hide();
	$('#commentCanvas').hide();
	$('#displayCanvas').hide();
	$('#imageTemp').hide();
	
	currentComment = idx;
	
	annImg = $('.commentCmt'+idx).attr('annotationFile');
	if(annImg.length > 0)
	{
		loadAnnotation(annImg);
	}
	else
	{

	}
	
	$('.prjCmtRow').css('border-left','3px solid transparent');
	$('#cmnt_'+idx).css('border-left','3px solid ' + $('#cp_'+idx).css('background-color'));
			
	if($('.prj-comments').length > 0 && doScroll) // Back end
	{
		$('.prj-file-details-main').scrollTop($('.prj-file-details-main').scrollTop() + ($('#cmnt_'+idx).position().top - $('.prj-file-details-main').position().top) - ($('.prj-file-details-main').height()/2) + ($('#cmnt_'+idx).height()/2));
	
		if($('#prj_file_detail_select').val() != 'tab2')
		{
			$('#prj_file_detail_select option:eq(1)').prop('selected', true);
			$('.prj-fileDetail-tab').hide();
			$('#tab2').fadeIn();
			selectedTab =  $('#tab2').val();
		}
	
	}
	else if($('#pstd_comments').length > 0 && doScroll) // Front End
	{
		$('.commentDiv').scrollTop($('.commentDiv').scrollTop() + ($('#cmnt_'+idx).position().top - $('.commentDiv').position().top) - ($('.commentDiv').height()/2) + ($('#cmnt_'+idx).height()/2));		
	}
}




function exitDraw()
{
	clearCanvas();
	$('#commentCanvas').hide();
	$('#imageTemp').hide();
}

function drawStackPush() {
    drawStep++;
    
    if (drawStep < drawStack.length) { drawStack.length = drawStep; }
    drawStack.push(document.getElementById('commentCanvas').toDataURL());
}

function drawStackUndo() 
{
    if (drawStep > 0) 
    {
        drawStep--;
        var canvasPic = new Image();
        canvasPic.src = drawStack[drawStep];
          
		canvasPic.onload = function () {           
			contexto.clearRect(0, 0, canvas.width, canvas.height);  
			contexto.drawImage(canvasPic, 0, 0);
   		}
    }
}

function drawStackRedo() {
    if (drawStep < drawStack.length-1) {
        drawStep++;
        var canvasPic = new Image();
        canvasPic.src = drawStack[drawStep];
        canvasPic.onload = function () { 
   			contexto.clearRect(0, 0, canvas.width, canvas.height);  
			contexto.drawImage(canvasPic, 0, 0);
         }
    }
}

function selectTool(toolType)
{
	if(!drawInitialized)
		initCanvas();	
	drawInitialized = true;
	
	$('#commentCanvas').show();
	$('#imageTemp').show();
	$('#displayCanvas').hide();
	
	$('.dTool').removeClass('dToolselected');
	curTool = toolType;
	context.strokeStyle=curColor;
	context.lineWidth = 2;
		
	// Reset Cursor here - then set below
	switch (toolType)
	{
		case 'pencil':
			$('.dTool1').addClass('dToolselected');
			tool = new tools['pencil']();
			break;
		case 'line':
			$('.dTool2').addClass('dToolselected');
			tool = new tools['line']();
			break;
		case 'square':
			$('.dTool3').addClass('dToolselected');
			tool = new tools['rect']();
			break;
		case 'circle':
			$('.dTool4').addClass('dToolselected');
			tool = new tools['circle']();
			break;
		case 'arrow':
			$('.dTool5').addClass('dToolselected');
			tool = new tools['arrow']();
			break;
	}
}

function init_draw_color()
{
	if($(".drwColors").length > 0)
	{
		$(".drwColors").spectrum('destroy');
		// Setup Color Picker
		thisColor = $(".drwColors").attr('varColor');
		$('#drwColor').spectrum({
			color: thisColor,
			preferredFormat: "hex",
			showInput: true,
		    change: function(color) 
		    {
				thisBGID = '#drwColor';
				curColor = color;
				if(context)
				{
			    	context.strokeStyle=curColor;	
				}
			}
		});
	}
}

function loadImages(sources, callback) 
{
    var images = {};
    var loadedImages = 0;
    var numImages = 0;
    // get num of sources
    for(var src in sources) {
      numImages++;
    }
    for(var src in sources) {
      images[src] = new Image();
      images[src].onload = function() {
        if(++loadedImages >= numImages) {
          callback(images);
        }
      };
      images[src].src = sources[src];
    }
}

function loadAnnotation(img)
{
    var dcanvas = document.getElementById('displayCanvas');
    var dcontext = dcanvas.getContext('2d');
    
    clearDisplayCanvas();
   	$('#displayCanvas').attr('width',$('#drawImage').width());
	$('#displayCanvas').attr('height',$('#drawImage').height());
	$('#displayCanvas').css('margin-left',$('#drawImage').css('margin-left'));
   	$('#displayCanvas').css('display','block');
    
    var sources = {
        annotation: '/assets/projects/' + project_id + '/images/' + img };
      loadImages(sources, function(images) {
        dcontext.drawImage(images.annotation, 0, 0, dcanvas.width, dcanvas.height);
      });
}

function clearDisplayCanvas()
{
    var dcanvas = document.getElementById('displayCanvas');
    var dcontext = dcanvas.getContext('2d');
    dcontext.clearRect(0, 0, dcanvas.width, dcanvas.height);
}


function clearCanvas()
{
	clearDisplayCanvas();
	if(context && context.clearRect != "undefined")
	{
		context.clearRect(0, 0, canvas.width, canvas.height);
		contexto.clearRect(0, 0, canvas.width, canvas.height);
		$( "#drawTxt" ).remove();
	}
	drawStack.splice(0, drawStack.length);
	drawStep = -1;
	drawStackPush();
}

function isCanvasBlank(canvas) {
  const context = canvas.getContext('2d');

  try {
  	const pixelBuffer = new Uint32Array(
		context.getImageData(0, 0, canvas.width, canvas.height).data.buffer
  	);
	
  	return !pixelBuffer.some(color => color !== 0);
  }
  catch(e)
  {
  	return true;
  }
}

function saveCanvas()
{
	// Get the current timestamp, grab the image and stuff into the db & file system
	// Check for annotation turned on - if yes save the image to the timestamp
	comment = $('#annotatedComment').val();
	
	if(comment == '')
	{
		alert('Please enter a comment.');
		return;
	}	
	id = $('#cmt_id').val();
	pid = $('#cmt_pid').val();
	email = $('#cmt_email').val();
	approvalID = $('#cmt_aid').val();
	var dataURL = '';
	var frameData = '';
	var coords='';
	var canvas = document.getElementById('commentCanvas');
	
	if(!isCanvasBlank(canvas) && canvas != null && canvas.toDataURL() != document.getElementById('blankCanvas').toDataURL())
	{
		dataURL = canvas.toDataURL();
	}
	else 
	{		
		if(typeof(load_after_comment) == 'function')
			add_comment($("#cmt_id").val(), $("#cmt_pid").val(), $("#cmt_aid").val(), $("#annotatedComment").val(), $("#cmt_email").val());	
		else	
			add_comment($("#cmt_id").val(), $("#cmt_pid").val(), $("#annotatedComment").val());		
		
		alert('Comment saved.');	
		
		$('#annotatedComment').val(''); 
		$('#annotatedComment').prop('disabled', false); 
		$('#ac_save').removeClass('active');    
		clearCanvas();		
		return;		
	}

	comment = $.trim(comment);
	if(comment.length <= 0)
		comment = 'Annotated Comment';
	 
	$('#ac_save').removeClass('active');
	$('#ac_save').addClass('working');
	$('#annotatedComment').prop('disabled', true);

	if(typeof(load_after_comment) == 'function')
	{
		
		$.post(base_url+'sp/approval/add_comment', {id: id, projectID: pid, comment: comment, approvalID: approvalID, imgdata: dataURL, coords: coords, email: email}, function(data) { 
			
			$('#pstd_comments').html(data);
			//var commentCount = $('.prjCmtRow').length;
			var commentCount =  $('.commentDiv').find('.prjCmtRowCmt').length;

			if(commentCount < 10)
				commentCount = '&nbsp;' + commentCount;

			if($('.prs-comments-icon span').length > 0)
			{
				$('.prs-comments-icon span').html(commentCount);	
			}
		
			$('#annotatedComment').val('');	
			$('#annotatedComment').prop('disabled', false);
			alert('Comment saved.');
			
			$.post(base_url+'sp/approval/reload_comments/' + id + '/' + pid + '/' + approvalID + '/' + email, function(data) { 
				$('#dynamicLoad').html(data);
			});	

			$('#ac_save').removeClass('working');
			$('.dTool').removeClass('dToolselected');
			clearCanvas();
		});
		
	}
	else
	{
		// Get current sort
		if($('#dateSort').length > 0 && $('#dateSort').hasClass('selected'))
			sortby = 'date';
		else	
			sortby = 'timestamp';
		
		$.post(base_url+'simian/projects/add_comment', {id: id, projectID: pid, comment: comment, timestamp: '', imgdata: dataURL, coords: '', sortBy: sortby}, function(data) { 
			if($('#commentsDiv').length > 0)
				$('#commentsDiv').html(data);
			
			var numComments =  $('#commentsDiv').find('.prjCmtRowCmt').length;
			if($('#fileselect_' + id + ' div.prj-thumb-container div.prj-thumb-comments').length > 0)
				$('#fileselect_' + id + ' div.prj-thumb-container div.prj-thumb-comments').html(numComments);
			else
				$('#fileselect_' + id + ' div.prj-thumb-container').append('<div class="prj-thumb-comments">'+ numComments + '</div>');

			$("#prj_file_detail_select option:contains(COMMENTS)").text('COMMENTS (' + numComments + ')');

			
			$('#annotatedComment').val('');	
			$('#annotatedComment').prop('disabled', false);
			alert('Comment saved.');
			updateComments(id,pid);
			// Refresh the player
			$('#ac_save').removeClass('working');
			$('.dTool').removeClass('dToolselected');
			clearCanvas();
			
		});
	}
}

function updateComments(mediaID, projectID)
{
	$.post(base_url+'simian/projects/reload_comments/' + mediaID, function(data) { 
		$('#dynamicLoad').html(data);
		resizeContent();
		init_controls();
	});	
}

function initCanvas () 
{
	// Find the canvas element.
    canvaso = document.getElementById('commentCanvas');
    if (!canvaso) 
    {
      alert('Error: canvas element not found!');
      return;
    }

    if (!canvaso.getContext) 
    {
      alert('Error: no canvas.getContext!');
      return;
    }

    // Get the 2D canvas context.
    contexto = canvaso.getContext('2d');
    if (!contexto) {
      alert('Error: failed to getContext!');
      return;
    }

	$( "#commentCanvas" ).clone().insertBefore( "#commentCanvas" ).attr('id','imageTemp');
	$('#imageTemp').css('zIndex',999200);
	$("#imageTemp").css('display','block');
	$("#commentCanvas").css('display','block');

	$('#imageTemp').attr('width',$('#drawImage').width());
	$('#imageTemp').attr('height',$('#drawImage').height());
    $('#imageTemp').css('margin-left',$('#drawImage').css('margin-left'));

	
	$('#displayCanvas').attr('width',$('#drawImage').width());
	$('#displayCanvas').attr('height',$('#drawImage').height());	
	$('#displayCanvas').css('margin-left',$('#drawImage').css('margin-left'));

	
	$('#blankCanvas').attr('width',$('#drawImage').width());
	$('#blankCanvas').attr('height',$('#drawImage').height());	
	$('#blankCanvas').css('margin-left',$('#drawImage').css('margin-left'));

	
	$('#commentCanvas').attr('width',$('#drawImage').width());
	$('#commentCanvas').attr('height',$('#drawImage').height());	
	$('#commentCanvas').css('margin-left',$('#drawImage').css('margin-left'));
	
	canvas = document.getElementById('imageTemp');
    context = canvas.getContext('2d');
	
	$(document).keypress(function( event ) 
	{
		if ( event.which == 27 || event.which == 0 ) 
		{
			event.preventDefault();
			$( "#drawTxt" ).remove();
		}
	});

    // Attach the mousedown, mousemove and mouseup event listeners.
    canvas.addEventListener('mousedown', ev_canvas, false);
    canvas.addEventListener('mousemove', ev_canvas, false);
    canvas.addEventListener('mouseup',   ev_canvas, false);
    
    // First time    
   	drawStackPush();	
}

// The general-purpose event handler. This function just determines the mouse 
// position relative to the canvas element.
function ev_canvas (ev) 
{
	ev._x = ev.offsetX;
    ev._y = ev.offsetY;
	// Call the event handler of the tool.
    var func = tool[ev.type];
    if (func) {
      func(ev);
    }
}

// This function draws the #imageTemp canvas on top of #imageView, after which 
// #imageTemp is cleared. This function is called each time when the user 
// completes a drawing operation.
function img_update () 
{
	contexto.drawImage(canvas, 0, 0);
	context.clearRect(0, 0, canvas.width, canvas.height);
	drawStackPush();	
	context.strokeStyle=curColor;
	context.lineWidth = 2;	
}

// This object holds the implementation of each drawing tool.
var tools = {};

  // The drawing pencil.
  tools.pencil = function () {
    var tool = this;
    this.started = false;


    // This is called when you start holding down the mouse button.
    // This starts the pencil drawing.
    this.mousedown = function (ev) {
		// Just in case.. 
		context.strokeStyle=curColor;
		context.lineWidth = 2;	


        context.beginPath();
        context.moveTo(ev._x, ev._y);
        tool.started = true;
    };

    this.mousemove = function (ev) {
      if (tool.started) {
        context.lineTo(ev._x, ev._y);
        context.stroke();
      }
    };

    this.mouseup = function (ev) {
      if (tool.started) {
        tool.mousemove(ev);
        tool.started = false;
        img_update();
      }
    };
  };

  // The rectangle tool.
  tools.rect = function () {
    var tool = this;
    this.started = false;

    this.mousedown = function (ev) {
   		// Just in case.. 
		context.strokeStyle=curColor;
		context.lineWidth = 2;	
    
      tool.started = true;
      tool.x0 = ev._x;
      tool.y0 = ev._y;
    };

    this.mousemove = function (ev) {
      if (!tool.started) {
        return;
      }

      var x = Math.min(ev._x,  tool.x0),
          y = Math.min(ev._y,  tool.y0),
          w = Math.abs(ev._x - tool.x0),
          h = Math.abs(ev._y - tool.y0);

      context.clearRect(0, 0, canvas.width, canvas.height);

      if (!w || !h) {
        return;
      }
      context.strokeRect(x, y, w, h);
    };

    this.mouseup = function (ev) {
      if (tool.started) {
        tool.mousemove(ev);
        tool.started = false;
        img_update();
      }
    };
  };
  
  // The text tool.
  tools.text = function () {
    var tool = this;
    this.started = false;

    this.mousedown = function (ev) {
      
		// Just in case.. 
		context.strokeStyle=curColor;
		context.lineWidth = 2;	
      
      if($('#drawTxt').length <= 0)
      {
     	 tool.x0 = ev._x;
	 	 tool.y0 = ev._y;
	 	 
	 	if($('#imageArea').length > 0)
		{
	 		yOffset = $('#imageTemp').position().top;
	 		xOffset = $('#imageTemp').position().left;
	 		$('#imageArea').append('<input type="text" id="drawTxt" value="" placeholder="Enter Text" style="width:250px;border:1px solid #fff;padding:3px;z-index:9999999;top:' +  (tool.y0+yOffset)  + 'px;left:' +  (tool.x0+xOffset)  + 'px;position: absolute;font-size:14px;font-weight:normal;font-family:arial;background:transparent;color:' + curColor + '">');

	 	}
	 	else
	 	{
	 		yOffset = $('.videoPlayer').position().top;
	 		xOffset = $('.videoPlayer').position().left;
		 	$('.videoPlayer').append('<input type="text" id="drawTxt" value="" placeholder="Enter Text" style="width:250px;border:1px solid #fff;padding:3px;z-index:9999999;top:' +  (tool.y0+yOffset)  + 'px;left:' +  (tool.x0+xOffset-33)  + 'px;position: absolute;font-size:14px;font-weight:normal;font-family:arial;background:transparent;color:' + curColor + '">');

	 	}
	 	tool.started = true;
		var isResize = false;
	 	 
	 	$( "#drawTxt" ).focusout(function( event ) 
		{
			event.preventDefault();
		 	if($('#imageArea').length > 0)
			{
		 		yOffset = $('#imageTemp').position().top;
		 		xOffset = $('#imageTemp').position().left;
		 	}
		 	else
		 	{
		 		yOffset = $('.videoPlayer').position().top;
		 		xOffset = $('.videoPlayer').position().left;
		 		isResize = true;
		 	}
	 		// Draw the text at the specified location
			 context.fillStyle = curColor;
			 context.font = "normal 14px Arial";
			 if(isResize)
				 context.fillText($( "#drawTxt" ).val(), (ev._x + 3) , (ev._y + 17));
			 else
			 	context.fillText($( "#drawTxt" ).val(), (ev._x + 3) , (ev._y + 17));
			// Remove handler
			$( "#drawTxt" ).remove();
			tool.started = false;
			img_update();
		}); 
	 	 
		$( "#drawTxt" ).keypress(function( event ) 
		{
			if ( event.which == 13 ) 
			{
				event.preventDefault();
				if($('#imageArea').length > 0)
				{
			 		yOffset = $('#imageTemp').position().top;
			 		xOffset = $('#imageTemp').position().left;
			 	}
			 	else
			 	{
			 		yOffset = $('.videoPlayer').position().top;
			 		xOffset = $('.videoPlayer').position().left;
			 		isResize = true;
			 	}
				// Draw the text at the specified location
				 context.fillStyle = curColor;
				 context.font = "bold 14px Arial";
				 if(isResize)
				 	context.fillText($( "#drawTxt" ).val(), (ev._x + 3) , (ev._y + 17));
				 else
					 context.fillText($( "#drawTxt" ).val(), (ev._x + 3), (ev._y + 17));
				// Remove handler
				$( "#drawTxt" ).remove();
				tool.started = false;
				img_update();
			}
		});
		
		}
    };

    this.mousemove = function (ev) {
      if (!tool.started) {
        return;
      }
    };

    this.mouseup = function (ev) {
      if (tool.started) {
      }
    };
  };
  
  // The circle tool.
  tools.circle = function () {
    var tool = this;
    this.started = false;

    this.mousedown = function (ev) {
    	// Just in case.. 
		context.strokeStyle=curColor;
		context.lineWidth = 2;	
    
      tool.started = true;
      tool.x0 = ev._x;
      tool.y0 = ev._y;
    };

    this.mousemove = function (ev) {
      if (!tool.started) {
        return;
      }

      var x = Math.min(ev._x,  tool.x0),
          y = Math.min(ev._y,  tool.y0),
          w = Math.abs(ev._x - tool.x0),
          h = Math.abs(ev._y - tool.y0);

      context.clearRect(0, 0, canvas.width, canvas.height);

      if (!w || !h) {
        return;
      }

	  context.beginPath();
      context.arc(x, y, h, 0, 2 * Math.PI, false);
      context.stroke();
    };

    this.mouseup = function (ev) {
      if (tool.started) {
        tool.mousemove(ev);
        tool.started = false;
        img_update();
      }
    };
  };
 
  
    // The eraser tool.
    tools.eraser = function () {
    var tool = this;
    this.started = false;
		context.strokeStyle = "rgba(0,0,0,1)";
		context.fillStyle = 'rgba(0,0,0,1)';
		eraseWidth= 20;
	
    this.mousedown = function (ev) {
        context.beginPath();
        context.moveTo(ev._x, ev._y);
        tool.started = true;
    };

    this.mousemove = function (ev) {
      if (tool.started) 
      {
		  var x2 = ev._x-(eraseWidth/2);          //x2 is used to center the erased rectangle at the mouse point
		  var y2 = ev._y-(eraseWidth/2);          //y2 is used to center the erased rectangle at the mouse point
		  contexto.clearRect(x2, y2, eraseWidth, eraseWidth);              //clear the rectangle at the mouse point (x2 and y2)
		  contexto.closePath();
 		  context.clearRect(x2, y2, eraseWidth, eraseWidth);              //clear the rectangle at the mouse point (x2 and y2)
		  context.closePath();
      }
    };

    // This is called when you release the mouse button.
    this.mouseup = function (ev) {
      if (tool.started) {
        tool.mousemove(ev);
        tool.started = false;
        img_update();
      }
    };
  };
  

  // The line tool.
  tools.line = function () {
    var tool = this;
    this.started = false;

    this.mousedown = function (ev) {
    	// Just in case.. 
		context.strokeStyle=curColor;
		context.lineWidth = 2;	
    
      tool.started = true;
      tool.x0 = ev._x;
      tool.y0 = ev._y;
    };

    this.mousemove = function (ev) {
      if (!tool.started) {
        return;
      }

      context.clearRect(0, 0, canvas.width, canvas.height);
      context.beginPath();
      context.moveTo(tool.x0, tool.y0);
      context.lineTo(ev._x,   ev._y);
      context.stroke();
      context.closePath();
    };

    this.mouseup = function (ev) {
      if (tool.started) {
        tool.mousemove(ev);
        tool.started = false;
        img_update();
      }
    };
  };

// The arrow tool.
 tools.arrow = function () {
    var tool = this;
    this.started = false;

    this.mousedown = function (ev) {
    	// Just in case.. 
		context.strokeStyle=curColor;
		tool.started = true;
		tool.x0 = ev._x;
		tool.y0 = ev._y;
    };

    this.mousemove = function (ev) {
		if (!tool.started) {
		return;
		}
		var headlen = 10;
		
		var angle = Math.atan2( ev._y- tool.y0, ev._x- tool.x0);
		
		//starting path of the arrow from the start square to the end square and drawing the stroke
		context.clearRect(0, 0, canvas.width, canvas.height);
		context.beginPath();
		context.moveTo( tool.x0,  tool.y0);
		context.lineTo(ev._x, ev._y);
		context.lineWidth = 3;
		context.stroke();
		
		//starting a new path from the head of the arrow to one of the sides of the point
		context.beginPath();
		context.moveTo(ev._x, ev._y);
		context.lineTo(ev._x-headlen*Math.cos(angle-Math.PI/7),ev._y-headlen*Math.sin(angle-Math.PI/7));
		
		//path from the side point of the arrow, to the other side point
		context.lineTo(ev._x-headlen*Math.cos(angle+Math.PI/7),ev._y-headlen*Math.sin(angle+Math.PI/7));
		
		//path from the side point back to the tip of the arrow, and then again to the opposite side point
		context.lineTo(ev._x, ev._y);
		context.lineTo(ev._x-headlen*Math.cos(angle-Math.PI/7),ev._y-headlen*Math.sin(angle-Math.PI/7));
    };

    this.mouseup = function (ev) {
		if (tool.started) {
			tool.mousemove(ev);
		
			//draws the paths created above
			context.lineWidth = 3;
			context.stroke();
			context.fillStyle = curColor;
			context.fill();       
			
			tool.started = false;
			img_update();
		}
    };
};